// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'vCal.pas' rev: 3.00

#ifndef vCalHPP
#define vCalHPP
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Vcal
{
//-- type declarations -------------------------------------------------------
enum TvEventStatus { esAccepted, esNeedsAction, esSent, esTentative, esConfirmed, esDeclined, esCompleted, 
	esDelegated };

enum TvEventTransp { etFree, etNotFree, etOther };

enum TvEventClass { ecPublic, ecPrivate, ecConfidential };

enum TvEventCategory { caAppointment, caBusiness, caEducation, caHoliday, caMeeting, caMiscellaneous, 
	caPersonal, caPhonecall, caSickDay, caSpecialOccasion, caTravel, caVacation };

enum TEventProperty { epDTStart, epDTEnd, epStatus, epPriority, epSummary, epTransp, epDescription, 
	epURL, epUID, epLocation, epClass, epCategories, epResources };

typedef Set<TvEventCategory, caAppointment, caVacation>  TvEventCategories;

class DELPHICLASS TvEvent;
class PASCALIMPLEMENTATION TvEvent : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::TDateTime FDTEnd;
	System::TDateTime FDTStart;
	int FPriority;
	TvEventStatus FStatus;
	System::AnsiString FSummary;
	TvEventTransp FTrans;
	Classes::TStrings* FDescription;
	System::AnsiString FURL;
	System::AnsiString FUID;
	System::AnsiString FLocation;
	TvEventClass FClass;
	TvEventCategories FCategories;
	Classes::TStrings* FResources;
	void __fastcall SetDTEnd(const System::TDateTime Value);
	void __fastcall SetDTStart(const System::TDateTime Value);
	void __fastcall SetPriority(const int Value);
	void __fastcall SetStatus(const TvEventStatus Value);
	void __fastcall SetSummary(const System::AnsiString Value);
	void __fastcall SetTransp(const TvEventTransp Value);
	void __fastcall SetDescription(const Classes::TStrings* Value);
	void __fastcall SetUID(const System::AnsiString Value);
	void __fastcall SetURL(const System::AnsiString Value);
	void __fastcall SetLocation(const System::AnsiString Value);
	void __fastcall SetClass(const TvEventClass Value);
	void __fastcall SetCategories(const TvEventCategories Value);
	void __fastcall SetResources(const Classes::TStrings* Value);
	
public:
	__fastcall virtual TvEvent(Classes::TCollection* Collection);
	__fastcall virtual ~TvEvent(void);
	
__published:
	__property TvEventCategories Categories = {read=FCategories, write=SetCategories, nodefault};
	__property TvEventClass Classification = {read=FClass, write=SetClass, nodefault};
	__property Classes::TStrings* Description = {read=FDescription, write=SetDescription};
	__property System::TDateTime DTEnd = {read=FDTEnd, write=SetDTEnd};
	__property System::TDateTime DTStart = {read=FDTStart, write=SetDTStart};
	__property System::AnsiString Location = {read=FLocation, write=SetLocation};
	__property int Priority = {read=FPriority, write=SetPriority, nodefault};
	__property Classes::TStrings* Resources = {read=FResources, write=SetResources};
	__property TvEventStatus Status = {read=FStatus, write=SetStatus, nodefault};
	__property System::AnsiString Summary = {read=FSummary, write=SetSummary};
	__property TvEventTransp Transp = {read=FTrans, write=SetTransp, nodefault};
	__property System::AnsiString URL = {read=FURL, write=SetURL};
	__property System::AnsiString UID = {read=FUID, write=SetUID};
};

class DELPHICLASS TvEventCollection;
class DELPHICLASS TvCalendar;
class PASCALIMPLEMENTATION TvCalendar : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TvEventCollection* FvEvents;
	System::AnsiString FProdID;
	System::AnsiString FTimeZone;
	TvEventCollection* __fastcall GetvEvents(void);
	void __fastcall SetvEvents(const TvEventCollection* Value);
	
public:
	__fastcall virtual TvCalendar(Classes::TComponent* AOwner);
	__fastcall virtual ~TvCalendar(void);
	void __fastcall LoadFromFile(const System::AnsiString FileName);
	void __fastcall InsertFromFile(const System::AnsiString FileName);
	void __fastcall SaveToFile(const System::AnsiString FileName);
	
__published:
	__property TvEventCollection* vEvents = {read=GetvEvents, write=SetvEvents};
	__property System::AnsiString ProdID = {read=FProdID, write=FProdID};
	__property System::AnsiString TimeZone = {read=FTimeZone, write=FTimeZone};
};

class PASCALIMPLEMENTATION TvEventCollection : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TvCalendar* FOwner;
	TvEvent* __fastcall GetvEvent(int Index);
	void __fastcall SetvEvent(int Index, const TvEvent* Value);
	
public:
	__fastcall TvEventCollection(TvCalendar* AOwner);
	HIDESBASE TvEvent* __fastcall Add(void);
	HIDESBASE TvEvent* __fastcall Insert(int Index);
	__property TvEvent* Items[int Index] = {read=GetvEvent, write=SetvEvent};
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
public:
	/* TCollection.Destroy */ __fastcall virtual ~TvEventCollection(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::AnsiString __fastcall StatusToStr(TvEventStatus AStatus);

}	/* namespace Vcal */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vcal;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// vCal
